// Donated by: Stefan Zechmeister <stefan@etm.co.at>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

// a sendmail app, which places the mail in the outbox of pmmail

/* Fold into RFC822 style */
int
fprintfold (FILE * f, char *t)
{
  int size = 0;
  while (*t)
    {
      if ((*t == '\r') || (*t == '\n'))
    {
      fprintf (f, "%c", 10);
      if (*(t + 1) == '\n')
        t++;
      size++;
    }
      else
    {
      putc (*t, f);
      size++;
    }
      t++;
    }
  return size;
}

void
putit (FILE * f, char *s)
{
  char *tmp = s;
  while (*tmp)
    {
      if ((*tmp != '\r') && (*tmp != '\n'))
    fputc (*tmp, f);
      tmp++;
    }
}
void
fprintbag (FILE * f, int yy, int mm, int dd, int h, int m, int s,
       char *subj, char *to_n, char *to_a, char *from_n, char
*from_a,
       int size, char *fil)

{
  char *tmp;
  fputc ('3', f);
  fputc (222, f);
  fputc ('0', f);
  fputc (222, f);
  fprintf (f, "%0.2d-%0.2d-%0.2d\xde%0.2d:%0.2d:%0.2d\xde",
       yy, mm, dd, h, m, s);
  putit (f, subj);
  fputc (222, f);
  putit (f, to_a);
  fputc (222, f);
  putit (f, to_n);
  fputc (222, f);
  putit (f, from_a);
  fputc (222, f);
  putit (f, from_n);
  fputc (222, f);

  fprintf (f, "%dK\xde%s\xde%c",
       size ? size : 1, fil, 10);

}

int
main (int argc, char *argv[])
{
  int size = 0;
  int header = 5;
  char sz[6];

  char *from_n = 0;
  char *from_a = 0;
  char *to_a = 0;
  char *to_n = 0;
  char *cc = 0;
  char *bcc = 0;
  char *subject = 0;
  char *xmailer = "Pilot PMMail 1.1\r\n";


  char *outbox_bag;
  char *outbox_path;
  char *outbox_file;
  char tmpfile[9];

  char line[256];

  int c;

  FILE *folder_bag;
  FILE *folder_msg;
  FILE *input;

  time_t tt;
  struct tm *t;

  if (argc != 4)
    {
      fprintf (stderr, "Usage: %s <pmmail account-folder> <from name>
<from email adress>\n", argv[0]);
      exit (-1);
    }
  from_n = strdup (argv[2]);
  from_a = strdup (argv[3]);

  outbox_path = (char *) malloc (strlen (argv[1]) + 11 + 1);
  sprintf (outbox_path, "%s\\OUTBOX.FLD", argv[1]);

  outbox_bag = (char *) malloc (strlen (outbox_path) + 11 + 1);
  sprintf (outbox_bag, "%s\\FOLDER.BAG", outbox_path);

  if (!(folder_bag = fopen (outbox_bag, "a")))
    {
      fprintf (stderr, "cant open file [%s]\n", outbox_bag);
      exit (-2);
    }

  strcpy (tmpfile, "SZXXXXXX");
  mktemp (tmpfile);
  outbox_file = (char *) malloc (strlen (outbox_path) + strlen
(tmpfile) + 1 + 1);
  sprintf (outbox_file, "%s\\%s", outbox_path, tmpfile);
  if (!(folder_msg = fopen (outbox_file, "a")))
    {
      fprintf (stderr, "cant open file [%s]\n", outbox_file);
      exit (-3);
    }
  while (fgets (line, 255, stdin))
    {
      if (header)
    {
      if (strstr (line, "From:") == line)
        ;           //ignored

      else if (strstr (line, "To:") == line)
        {
          char *p1 = strchr (line + 4, '<');
          char *p2 = strchr (line + 4, '>');
          if (p1)
        {
          to_n = (char *) malloc (p1 - line - 3);
          to_a = (char *) malloc (p2 - p1 + 1);
          strncpy (to_n, line + 4, p1 - line - 4 - 1);
          strncpy (to_a, p1 + 1, p2 - p1 - 1);
        }
          else
        to_a = strdup (line + 4);
        }
      else if (strstr (line, "Cc:") == line)
        {
          if (strlen (line) > 4)
        cc = strdup (line + 4);
        }
      else if (strstr (line, "Bcc:") == line)
        {
          if (strlen (line) > 5)
        bcc = strdup (line + 5);
        }
      else if (strstr (line, "Subject:") == line)
        {
          if (strlen (line) > 9)
        subject = strdup (line + 9);
        }
      else if (strstr (line, "X-mailer:") == line)
        header = 0;     //ignored

      if (!header)
        {           //write header

          fprintf (folder_msg, "From: %s <%s>%c", from_n, from_a,
10);
          size += strlen (from_n) + strlen (from_a) + 9;
          fprintf (folder_msg, "To: ");
          if (to_n && to_a)
        fprintf (folder_msg, "%s <%s>%c", to_n, to_a, 10);
          else
        size += 4 + fprintfold (folder_msg, to_a);
          if (cc)
        {
          fprintf (folder_msg, "Cc: ");
          size += 4 + fprintfold (folder_msg, cc);
        }
          if (bcc)
        {
          fprintf (folder_msg, "Bcc: ");
          size += 5 + fprintfold (folder_msg, bcc);
        }
          fprintf (folder_msg, "Subject: ");
          size += 9 + fprintfold (folder_msg, subject);
          fprintf (folder_msg, "X-mailer: ");
          size += 10 + fprintfold (folder_msg, xmailer);
        }
    }
      else
    {
      size += fprintfold (folder_msg, line);
    }
    }
  //now write bag-entry
  time (&tt);
  t = localtime (&tt);
  fprintbag (folder_bag, t->tm_year, t->tm_mon+1, t->tm_mday,
         t->tm_hour, t->tm_min, t->tm_sec,
         subject, to_n ? to_n : to_a, to_a, from_n, from_a, (int)
(size / 1024.0 + 0.5), tmpfile);

  fclose (folder_msg);
  fclose (folder_bag);

  free (to_a);
  free (to_n);
  free (cc);
  free (bcc);
  free (subject);
  free (outbox_bag);
  free (from_n), free (from_a);
  outbox_bag = (char *) malloc (strlen (outbox_path) + 11 + 1);
  sprintf (outbox_bag, "%s\\FOLDER.INI", outbox_path);
  if (folder_bag = fopen (outbox_bag, "r+"))
    {
      fgets (line, 38, folder_bag);
      fseek (folder_bag, 0L, SEEK_SET);
      fprintf (folder_bag, "%s1\xde", line);
      fclose (folder_bag);
    }

  free (outbox_bag);
  free (outbox_path);
  free (outbox_file);

}
